/**
  * Buchungssatz 
  * von Konto
  * nach Konto
  * Betrag
  * Calendar 
 **/ 

import java.util.Date;
import java.util.Calendar;
import java.text.DateFormat;


public class BuchungCalendar implements BuchungInterface {

    final static int NO_KONTO = -1;

    protected int vonKonto = NO_KONTO;
    protected int nachKonto = NO_KONTO;

    protected double betrag = 0.0;

    protected Calendar zeitStempel = null;
    protected DateFormat zeitFormat = null;

    public BuchungCalendar(int von, int nach, double b) {
        vonKonto = von;
        nachKonto = nach;
        betrag = b;
        zeitStempel = Calendar.getInstance();
        zeitStempel.setTime( new Date() );
        zeitFormat = DateFormat.getDateTimeInstance(
                        DateFormat.FULL,
                        DateFormat.FULL);
    }

    public int getVonKonto() { return vonKonto; }

    public int getNachKonto() { return nachKonto; }

    public double getBetrag() { return betrag; }

    public Date getZeit() { return zeitStempel.getTime(); }

    public boolean vor(BuchungInterface b) {
	return zeitStempel.before( b.getZeit() );
    }

    public boolean nach(BuchungInterface b) {
	return zeitStempel.after( b.getZeit() );
    }

    public String toString() {
        String s = "<" + getClass().getName();
        s +=  " von='"+vonKonto+"'";
        s +=  " nach='"+nachKonto+"'";
	s +=  " betrag='"+betrag+"'";
	s +=  " zeit='"+zeitFormat.format(zeitStempel.getTime())+"'";
	s +=  " />";
	return s;
    }
}
