
/**
  * Testen einer einfachen Ein- und Ausgabe
  * Eingabe von einer Datei
  * Ausgabe auf eine Datei
  *
 **/ 

import java.io.IOException;
import java.io.FileNotFoundException;

public class Dateien {

    public static void main(String[] args) {

        Screen sc = new Screen();

        if ( args.length < 1 ) {
	    sc.println("Usage: Dateien <eingabe datei> [<ausgabe datei>]");
            return;
	}

        DateiEin rein;
        DateiAus raus = null;

        try {
            rein = new DateiEin(args[0]);
	}
        catch (FileNotFoundException e) {
            sc.println("Die Datei " + args[0] + " existiert nicht.");
            return;
	}
        if ( args.length >= 2 ) {
           try {
               raus = new DateiAus(args[1]);
	   }
           catch (IOException e) {
                sc.println("Die Datei " + args[1] + " ist nicht beschreibbar.");
           }
	}

        String ea = "";
        int ein = 0;
	int aus = 0;

        try {
            do {
		ea = rein.readLine(); 
                if ( ea == null ) break;
                ein++;
                if ( raus == null ) {
	           sc.println(ea);
                } else {
                   raus.println(ea); 
                }
                aus++;
            } while ( !ea.equals("ende") );
	} 
        catch (IOException e) {
	    e.printStackTrace();
	}
	finally {
	    if ( raus != null ) raus.flush();
	}

        try {
	    rein.close();
	    if ( raus != null ) raus.close();
	}
        catch (IOException e) {
	    e.printStackTrace();
	}

        sc.println(""+ein+" Zeilen von " + args[0] + " gelesen");
        if ( args.length >= 2 )
           sc.println(""+aus+" Zeilen auf " + args[1] + " geschrieben");
    }

}
