/**
 * HalloObj Test using JUnit
 *
 */

import junit.framework.*;
import java.io.*;

public class HalloObjTest extends TestCase {

   public static void main (String[] args) {
          junit.textui.TestRunner.run( suite() );
   }

   public HalloObjTest(String name) {
          super(name);
   }

   public static Test suite() {
     TestSuite suite= new TestSuite(HalloObjTest.class);
     return suite;
   }

   public void testHalloObj0() {
       HalloObj ho = new HalloObj(System.out);
       assertEquals(false, (ho == null) );
   }

   public void testHalloObj1() {
       PipedInputStream pi = new PipedInputStream();
       InputStreamReader is = new InputStreamReader(pi);

       PipedOutputStream po = null;
       try {
           po = new PipedOutputStream(pi);
       }
       catch (IOException e) {
	   fail("IOException "+e);
       }
       PrintStream ps = new PrintStream(po);

       HalloObj ho = new HalloObj( ps );
       assertEquals(false, (ho == null) );

       ho.sags();

       int l = 80;
       int r;
       char[] cbuf = new char[l];
       String emsg = "Hallo Welt!\n";
       try {
	   r=is.read(cbuf,0,l);
           String rmsg = new String(cbuf,0,r);
           int t = emsg.compareTo(rmsg);
           assertEquals(t,0);
       } catch(IOException e) {
           fail("IOException "+e);
       }

   }

   public void testHalloObj2() {
       PipedInputStream pi = new PipedInputStream();
       StringInputStreamReader is = new StringInputStreamReader(pi);

       PipedOutputStream po = null;
       try {
           po = new PipedOutputStream(pi);
       }
       catch (IOException e) {
	   fail("IOException "+e);
       }
       PrintStream ps = new PrintStream(po);

       HalloObj ho = new HalloObj( ps );
       assertEquals(false, (ho == null) );

       ho.sags();

       String emsg = "Hallo Welt!\n";
       try {
	   String rmsg = is.readString();
           int t = emsg.compareTo(rmsg);
           assertEquals(emsg,rmsg);
       } catch(IOException e) {
           fail("IOException "+e);
       }

   }


}

