
/**
  * Testen einer einfachen Ein- und Ausgabe
  * Eingabe von einer Datei
  * Ausgabe auf eine Datei
  *
 **/ 

import java.io.IOException;
import java.io.FileNotFoundException;

public class Anhang {

    public static void main(String[] args) {

        Screen sc = new Screen();

        if ( args.length < 2 ) {
	    sc.println("Usage: Anhang <eingabe datei> <ausgabe datei>");
            return;
	}

        DateiEin rein;
        DateiDran dran;

        try {
            rein = new DateiEin(args[0]);
	}
        catch (FileNotFoundException e) {
            sc.println("Die Datei " + args[0] + " existiert nicht.");
            return;
	}
        try {
            dran = new DateiDran(args[1]);
	}
        catch (IOException e) {
            sc.println("Die Datei " + args[1] + " ist nicht beschreibbar.");
            return;
	}

        String ea = "";
        int ein = 0;
	int aus = 0;

        try {
            do {
		ea = rein.readLine(); 
	        // sc.println("Eingabe: "+ea);
                if ( ea == null ) break;
                ein++;
                dran.println(ea); aus++;
            } while ( !ea.equals("ende") );
	} 
        catch (IOException e) {
	    e.printStackTrace();
	}
	finally {
	    dran.flush();
	}

        try {
	    rein.close();
	    dran.close();
	}
        catch (IOException e) {
	    e.printStackTrace();
	}

        sc.println(""+ein+" Zeilen von " + args[0] + " gelesen");
        sc.println(""+aus+" Zeilen auf " + args[1] + " geschrieben");
    }

}
