/**
  * Buchungssatz Test  
  * 
 **/ 

import java.util.Locale;
import java.io.IOException;


public class BuchungTest {

    public static void main(String[] args) {
        testDate();
        testCalendar();
        testCalendarFrance();
        testCalendarUS();
	//        testCalendarJapan();
        testCalendarItaly();
        testError();
        testCalendarResource();
    }

    static void testDate() {

        Screen sc = new Screen();
        KeyBoard kb = new KeyBoard();
        String s = "";

        BuchungInterface a = new BuchungDate(1,9,50.0);
	try {
            sc.println("press enter to continue");
            s = kb.readLine();
	}
	catch(IOException e) { }
        BuchungInterface b = new BuchungDate(9,2,100.0);

        sc.println("a = " + a);
        sc.println("b = " + b);

        boolean t = a.vor(b);
        sc.println("t = " + t);
        t = a.nach(b);
        sc.println("t = " + t);

        sc.println();
    }

    static void testCalendar() {

        Screen sc = new Screen();
        KeyBoard kb = new KeyBoard();
        String s = "";

        BuchungInterface a = new BuchungCalendar(1,9,50.0);
	try {
            sc.println("press enter to continue");
            s = kb.readLine();
	}
	catch(IOException e) { }
        BuchungInterface b = new BuchungCalendar(9,2,100.0);

        sc.println("a = " + a);
        sc.println("b = " + b);

        boolean t = a.vor(b);
        sc.println("t = " + t);
        t = a.nach(b);
        sc.println("t = " + t);

        sc.println();
    }

    static void testCalendarFrance() {

        Screen sc = new Screen();
        KeyBoard kb = new KeyBoard();
        String s = "";

        BuchungInterface a = new BuchungCalendarFrance(1,9,50.0);
        BuchungInterface b = new BuchungCalendarFrance(9,2,100.0);

        sc.println("a = " + a);
        sc.println("b = " + b);

        boolean t = a.vor(b);
        sc.println("t = " + t);

        sc.println();
    }

    static void testCalendarUS() {

        Screen sc = new Screen();
        KeyBoard kb = new KeyBoard();
        String s = "";

        BuchungInterface a = new BuchungCalendarUS(1,9,50.0);
        BuchungInterface b = new BuchungCalendarUS(9,2,100.0);

        sc.println("a = " + a);
        sc.println("b = " + b);

        boolean t = a.vor(b);
        sc.println("t = " + t);

        sc.println();
    }

    static void testCalendarJapan() {

        Screen sc = new Screen();
        KeyBoard kb = new KeyBoard();
        String s = "";

        BuchungInterface a = new BuchungCalendarJapan(1,9,50.0);
        BuchungInterface b = new BuchungCalendarJapan(9,2,100.0);

        sc.println("a = " + a);
        sc.println("b = " + b);

        boolean t = a.vor(b);
        sc.println("t = " + t);

        sc.println();
    }

    static void testCalendarItaly() {

        Screen sc = new Screen();
        KeyBoard kb = new KeyBoard();
        String s = "";

        BuchungInterface a = new BuchungCalendarItaly(1,9,50.0);
        BuchungInterface b = new BuchungCalendarItaly(9,2,100.0);

        sc.println("a = " + a);
        sc.println("b = " + b);

        boolean t = a.vor(b);
        sc.println("t = " + t);

        sc.println();
    }

    static void testCalendarResource() {

        Screen sc = new Screen();
        KeyBoard kb = new KeyBoard();
        String s = "";

        BuchungInterface a = new BuchungCalendarResource(1,9,50.0);
        sc.println("a = " + a);

        Locale.setDefault( Locale.FRANCE );
        BuchungInterface b = new BuchungCalendarResource(9,2,100.0);
        sc.println("b = " + b);

        Locale.setDefault( Locale.US );
        BuchungInterface c = new BuchungCalendarResource(3,4,99.0);
        sc.println("c = " + c);

        Locale.setDefault( Locale.ITALY );
        BuchungInterface d = new BuchungCalendarResource(5,2,130.0);
        sc.println("d = " + d);

        Locale.setDefault( Locale.GERMANY );
        BuchungInterface e = new BuchungCalendarResource(4,7,60.0);
        sc.println("e = " + e);

        boolean t;
        t = a.vor(b);
        sc.println("a.vor(b) = " + t);
        t = a.vor(c);
        sc.println("a.vor(c) = " + t);
        t = e.vor(c);
        sc.println("e.vor(c) = " + t);
        t = d.vor(a);
        sc.println("d.vor(a) = " + t);

        sc.println();
    }

    static void testError() {

        Screen sc = new Screen();
        KeyBoard kb = new KeyBoard();
        String s = "";

        BuchungInterface a = new BuchungDate(1,9,50.0);
        BuchungInterface b = new BuchungCalendar(9,2,100.0);
        BuchungInterface c = new BuchungCalendarFrance(2,3,50.0);
        BuchungInterface d = new BuchungCalendarUS(3,5,99.0);
        BuchungInterface e = new BuchungCalendarItaly(6,2,15.0);

        sc.println("a = " + a);
        sc.println("b = " + b);
        sc.println("c = " + c);
        sc.println("d = " + d);
        sc.println("e = " + e);

        boolean t;
        t = a.vor(b);
        sc.println("a.vor(b) = " + t);
        t = a.vor(c);
        sc.println("a.vor(c) = " + t);
        t = e.vor(c);
        sc.println("e.vor(c) = " + t);
        t = d.vor(a);
        sc.println("d.vor(a) = " + t);

        sc.println();
    }


}
