import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document; 
import org.w3c.dom.Node; 
import org.w3c.dom.Element; 
import java.io.IOException;
import org.xml.sax.SAXException;

import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.SAXParser;
import org.xml.sax.helpers.DefaultHandler;


public class Rechnung {

    public static void main(String[] args) {

	Screen sc = new Screen();
	if (args.length < 3) {
	    sc.println("Usage: Rechnung" +
                       " <lagerdatei.xml>" +
                       " <lieferung.xml>" +
                       " <rechnung.xml>");
            return;
	}

	// Lager einlesen: 
	DocumentBuilderFactory lpfac = DocumentBuilderFactory.newInstance();
	DocumentBuilder lparser = null;

	try {
	   lpfac.setValidating(true);
	   lparser = lpfac.newDocumentBuilder();
	}
	catch (ParserConfigurationException e) {
	    e.printStackTrace();
	}

	Document lager = null;
        String lauri = args[0];

	try {
            lager = lparser.parse(lauri);
	}
	catch (SAXException e) {
	    e.printStackTrace();
	}
	catch (IOException e) {
	    e.printStackTrace();
	}


	// Lieferschein einlesen und Rechnung schreiben: 
	SAXParserFactory lipfac = SAXParserFactory.newInstance();
	SAXParser liparser = null;

	try {
	   lipfac.setValidating(true);
	   lipfac.setNamespaceAware(true);
	   liparser = lipfac.newSAXParser();
	}
	catch (ParserConfigurationException e) {
	    e.printStackTrace();
	}
	catch (SAXException e) {
	    e.printStackTrace();
	}

        String liuri = args[1];
        String reuri = args[2];
        DateiAus red = null;
	try {
            red = new DateiAus(reuri);
	}
	catch (IOException e) {
            sc.println("Fehler Ausgabedatei "+reuri);
            e.printStackTrace();
        }

	DOMLager domLager = new DOMLager(lager); 
	DefaultHandler dh = new SAXRechnung(red,domLager);
	try {
            liparser.parse(liuri,dh);
	}
	catch (SAXException e) {
	    e.printStackTrace();
	}
	catch (IOException e) {
	    e.printStackTrace();
	}

    }

}
