
public class BitString extends Object {

    private int art;

    final static int BYTE  = 1;
    final static int SHORT = 2;
    final static int INT   = 3;
    final static int LONG  = 4;

    final static int BYTEsize  =  7;
    final static int SHORTsize = 15;
    final static int INTsize   = 31;
    final static int LONGsize  = 63;

    byte bs = 0;
    short ss = 0;
    int is = 0;
    long ls = 0;

    public BitString(byte b) {
        art = BYTE;
	bs = b;
    }

    public BitString(short s) {
        art = SHORT;
	ss = s;
    }

    public BitString(int s) {
        art = INT;
	is = s;
    }

    public BitString(long s) {
        art = LONG;
	ls = s;
    }

    public String toString() {
        switch (art) {
          case  BYTE: return bitString(bs);
          case SHORT: return bitString(ss);
          case   INT: return bitString(is);
          case  LONG: return bitString(ls);
	     default: return "";
	}
    }

    public static String bitString(byte b) {
        String e = "";
        String s;
        byte x;
        byte zwei = (byte)2;

        if (b < 0 ) {
	    x = (byte)-b; s = "1";
	} else {
            x = b; s = "0";
	}

        for (int i = 0; i < BYTEsize; i++) { 
            if ( (byte)(x % zwei) == 0 ) { e = "0" + e; }
	    else { e = "1" + e; }
            x = (byte)(x >> 1);
	}

        return s+e;
    }


    public static String bitString(short b) {
        String e = "";
        short x;
        String s;
        short zwei = (short)2;

        if (b < 0 ) {
            x = (short)-b; s = "1";
	} else {
            x = b; s = "0";
	}

        for (int i = 0; i < SHORTsize; i++) { 
            if ( (byte)(x % zwei) == 0 ) { e = "0" + e; }
	    else { e = "1" + e; }
            x = (short)(x >> 1);
	}

        return s+e;
    }

    public static String bitString(int b) {
        String e = "";
        int x;
        String s;
        int zwei = (int)2;

        if (b < 0 ) {
	    x = (int)-b; s = "1";
	} else {
            x = b; s = "0";
	}

        for (int i = 0; i < INTsize; i++) { 
            if ( (byte)(x % zwei) == 0 ) { e = "0" + e; }
	    else { e = "1" + e; }
            x = (int)(x >> 1);
	}

        return s+e;
    }

    public static String bitString(long b) {
        String e = "";
        long x;
        String s;
        long zwei = (long)2;
        long nmax = -(long)2^LONGsize-1;

        if (b < 0 ) {
	    x = (long)-b; s = "1";
	} else {
            x = b; s = "0";
	}

        for (int i = 0; i < LONGsize; i++) { 
            if ( (byte)(x % zwei) == 0 ) { e = "0" + e; }
	    else { e = "1" + e; }
            x = (long)(x >> 1);
	}

        return s+e;
    }

}
